from machine import Pin
import time

#Michael Wang and Jung Ki Lee
#12/11/2021
#This program allows our Morse Code Translators to communicate eachother, but not in morse code!
#Rather, the devices commicate by beaming the ASCII values of characters to one another, bit by bit.



asc = 0
ascr = 0
message = ""
signal = 0
signalcount = 0
rcounter = 0
i = 0
endthreshold = 7
laser = Pin(16, Pin.OUT)
light = Pin(15, Pin.IN)

while (True):
    mode = input("press 's' to send, 'r' to receive: ")
    
    #code for receiving messages
    if(mode == 'r'):
        print("Waiting for start signal...")
        while True:
            if(light.value() == 1):
                signalcount = signalcount + 1
                print("light", signalcount)
                time.sleep(0.5)
            else:
                print("dark")
                signalcount = 0
                time.sleep(0.5)
            if(signalcount == 4):
                print("Start signal recieved. Recording: ")
                time.sleep(0.02)
                signalcount = 0
                break;
        while True:
            counter = 7
            if(ascr != 0 and signalcount < endthreshold):
                print(chr(ascr))
            ascr = 0
            if(signalcount < endthreshold):
                print("working on letter: ", rcounter+1)
                rcounter = rcounter + 1
            if (signalcount > endthreshold):
                print("END SIGNAL REACHED")
                break;
            while (counter > -1):
                if(light.value() == 1):
                    ascr += 2**counter
                    signalcount += 1
                elif(light.value() == 0):
                    signalcount = 0
                if (signalcount > endthreshold):
                    break;
                print(light.value())
                counter = counter - 1
                time.sleep(0.5)
            if(signalcount < endthreshold):
                message = message + chr(ascr)
        print("Message:", message)
        
        
    #code for sending messages            
    elif(mode == 's'):

        msg = input("Enter your message: ")
        laser.value(1)
        time.sleep(2)

        while i < len(msg):
            laser.value(0)
            asc = (ord(msg[i])) #ascii value of letter
            bit = 0  #bitcount
            print("index: ", i)
            while bit < 8: # this loop expresses ascii value of letter in 8-bit binary and converts to laser.
                if(asc-128 > -1):
                    signal = 1
                else:
                    signal = 0
                laser.value(signal)
                time.sleep(0.5)
                print(signal)
                bit += 1
                asc = (asc << 1) & 255 #windowed left shift
            i += 1
        laser.value(1)
        time.sleep(4.0)
        laser.value(0)
        print("message sent.")
            
    else:
        print("Invalid input. Enter s or r")

    
